#! /usr/local/bin/python
import string
import sys


###############################################################
#  break up a string in this fashion. For 'aaa [bbb:ccc] ddd',
#  return the tuple (aaa, bbb, ccc, ddd).
#
def breakUp(s):
    i = string.find(s, '[')
    if (i == -1):
	return (s, '', '', '')

    p0 = s[:i]
    s = s[i+1:]
    i = string.find(s, ']')
    p3 = s[i+1:]
    s = s[:i]
    i = string.find(s, ':')
    p1 = s[:i]
    p2 = s[i+1:]
    return (p0, p1, p2, p3)


###############################################################
#  parse the body of a query
#  return tuplet (sql statement, parameters, results)
def parseQuery(body):
    token = []
    while (body != ''):
	p = breakUp(body)
	token = token + [(p[0], '')] + [(p[1], p[2])]
	body = p[3]

    sql = ''
    for t in token:
	sql = sql + t[0]

    param = []
    for t in token:
	if t[0] == '?':
	    p = string.split(t[1])
	    param = param + [(p[0], p[1])]

    res = []
    for t in token:
	if t[0] != '?' and t[1] != '':
	    p = string.split(t[1])
	    res = res + [(p[0], p[1])]

    return (sql, param, res)



###############################################################
#  Write text to fname if content of fname is different from text
#  return 1 if written, 0 otherwise
def writeIfDiff(fname, text):
    try:
	file = open(fname, 'r')
	old = file.read(-1)
	file.close()
    except IOError:
	old = ''

    if old != text:
	file = open(fname, 'w+')
	file.write(text)
	file.close()
	return 1

    return 0

