#! /usr/bin/python
import string
from mkqry import *

###############################################################
#  
s_package = 'db'

s_query = [
("SelectEmployeeById", '''\
select [id:long id], [name:String name], [salary:float salary], 
       [hire_date:Timestamp hireDate]
  from EMPLOYEE
 where id = [?:long id]'''),
]


###############################################################
#  
def makeSelectClass(idx, name, sql, param, res):
    text = '''\
/*
 *  WARNING: THIS FILE IS GENERATED. DO NOT MODIFY.
 */
'''
    text = text + 'package ' + s_package + ';'

    text = text + '''

import java.sql.*;
import java.io.*;
import java.util.*;

public final class %s
                extends DbQuery
{
    private final static String NAME = "%s";
    private final static Statistic STAT 
	    = new Statistic("%s");
    public final static String SQL = 
         "%s";

'''

    text = text % (name, name, name, string.replace(sql, '\n', ' "\n       + "'))

    for p in param:
        text = text + ('''\
    private %s m_%s;
''' % p)

    if len(res) > 0:
        tmp = ()
        for r in res:
	    if (r[0] == "bytes"):
	        r = ("byte[]", r[1])
            elif (r[0] == "utf8"):
	        r = ("String", r[1])
            tmp = tmp + r
        text = text + '''
    public static class Row 
    {
'''
        text = text + ("        public %s %s;\n" * len(res) % tmp)
        text = text + '''\

	public Row copyRow()
	{
	    Row row = new Row();
'''
	for r in res:
	    text = text + '            ';
	    copyOp = r[1]
	    if (r[0] == 'Timestamp'):
	        copyOp = ('%s == null ? null : new Timestamp(%s.getTime())' 
		            % (r[1], r[1]))

	    text = text + ("row.%s = %s;\n" % (r[1], copyOp))

	text = text + '''\

	    return row;
	}
    }
'''

        text = text + '''\

    Row m_row = new Row();

    protected final Object fillResult(final ResultSet rs)
                throws SQLException 
    {
        if (null == rs) {
            m_row = null;
        }
        else {
            int i = 1;
'''

        tmp = ()
        for r in res:
	    g = ''
	    if r[0] == 'boolean': g = '"t".equals(rs.getString(i++))'
	    elif r[0] == 'utf8' : g = 'UTF8toString(rs.getBytes(i++))'
	    else: g = 'rs.get' + string.capitalize(r[0]) + '(i++)'
            tmp = tmp + (r[1], g)
        text = text + ("            m_row.%s = %s;\n" * len(res) % tmp)
        text = text + '''\
        }
        return m_row;
    }


'''

    # execute
    text = text + '''
    public static final Row getOneRow(final DbTrans trans'''
    for p in param:
        text = text + (',\n            final %s %s' % p)
    
    text = text + ')\n'
    text = text + '    {\n'
    text = text + ('        %s q;\n' % name)
    text = text + ('        q = new %s(trans' % name)
    for p in param:
        text = text + (',\n                %s' % p[1])
    text = text + ');\n'

    text = text + '''
	Row r = null;	
        try {
            q.execute();
	    r = q.nextRow();
        }
        finally {
            q.close();
        }
        return r;
    }


'''

    text = text + '''
    public static final ArrayList getAllRows(final DbTrans trans'''
    for p in param:
        text = text + (',\n            final %s %s' % p)
    
    text = text + ')\n'
    text = text + '    {\n'
    text = text + ('        %s q;\n' % name)
    text = text + ('        q = new %s(trans' % name)
    for p in param:
        text = text + (',\n                %s' % p[1])
    text = text + ');\n'

    text = text + '''
	Row r = null;
	ArrayList list = new ArrayList();
        try {
            q.execute();
	    while (null != (r = q.nextRow()))
                list.add(r.copyRow());
        }
        finally {
            q.close();
        }
        return list;
    }


'''

    # constructor
    text = text + ('    public %s(\n' % name)
    text = text +  '            final DbTrans trans'

    for p in param:
        if (p[0] == 'bytes'):
	   p = ('byte[]', p[1])
        text = text + (',\n            final %s %s' % p)
    
    text = text + ')\n'
    text = text + '    {\n'
    text = text + '        super(trans, NAME, SQL, STAT);\n'
    
    for p in param:
        text = text + ('        m_%s = %s;\n' % (p[1], p[1]))
 
    text = text + '    }\n\n'


    text = text + '    protected final void fillParam(final PreparedStatement ps)\n'
    text = text + '            throws SQLException\n'
    text = text + '    {\n'
    text = text + '        int c = 1;\n'
    for p in param:
	g = ''
	if p[0] == 'boolean': 
	    g = 'ps.setString(c++, m_%s ? "t" : "f")'
	else: 
	    g = 'ps.set' + string.capitalize(p[0]) + '(c++, m_%s)'

        text = text + '        ' + (g % p[1]) + ';\n'

    text = text + '    }\n\n'

    text = text + '''\
    public final Row nextRow()
    {
        return (Row) super.next();
    }

}
'''
    
    return text



###############################################################
#  
if __name__ == '__main__':
    tuple = [];
    for idx in range(len(s_query)):
        tuple = tuple + [(idx, s_query[idx][0]) + parseQuery(s_query[idx][1])];

    # make select class
    for t in tuple:
        classText = makeSelectClass(t[0], t[1], t[2], t[3], t[4])
        fname = t[1] + '.java';
        diff = writeIfDiff(fname, classText)
        if diff:
            print 'touch:', fname
        else:
            print 'leave:', fname
