#! /usr/bin/python
import string
from mkqry import *

###############################################################
#  
s_package = 'db'

s_query = [

("InsertEmployee", '''\
insert into EMPLOYEE(id, name, salary, hire_date)
 values ([?:long id], [?:String name],
	 [?:float salary], [?:Timestamp hireDate])'''),


("DeleteEmployeeById", '''\
delete from EMPLOYEE where id = [?:long id]'''),

("UpdateEmployeeSalaryById", '''\
update EMPLOYEE set salary = [?:float salary]
 where id = [?:long id]'''),
]



###############################################################
#  
def makeUpdateClass(idx, name, sql, param, res):
    text = '''\
/*
 *  WARNING: THIS FILE IS GENERATED. DO NOT MODIFY.
 */
'''

    text = text + 'package ' + s_package + ';'

    text = text + '''

import java.sql.*;
import java.io.*;

public final class %s
                extends DbQuery
{
    private final static String name = "%s";

    private final static Statistic STAT 
	    = new Statistic("%s");
    public final static String SQL = 
         "%s";

'''

    text = text % (name, name, name, string.replace(sql, '\n', ' "\n       + "'))

    for p in param:
        if p[0] == 'bytes':
	    p = ('byte[]', p[1])
        text = text + ('    private %s m_%s;\n' % p)

    # execute
    text = text + '''
    public static final int execute(final DbTrans trans'''
    for p in param:
        if (p[0] == 'bytes'):
	    p = ('byte[]', p[1])
        text = text + (',\n            final %s %s' % p)
    
    text = text + ')\n'
    text = text + '    {\n'
    text = text + ('        %s q;\n' % name)
    text = text + ('        q = new %s(trans' % name)
    for p in param:
        text = text + (',\n                %s' % p[1])
    text = text + ');\n'

    text = text + '''
        int count;
        try {
            count = q.executeUpdate();
        }
        finally {
            q.close();
        }
        return count;
    }


'''

    # constructor
    text = text + ('    public %s(\n' % name)
    text = text +  '            final DbTrans trans'

    for p in param:
        if (p[0] == 'bytes'):
	    p = ('byte[]', p[1])
        text = text + (',\n            final %s %s' % p)
    
    text = text + ')\n'
    text = text + '    {\n'
    text = text + '        super(trans, name, SQL, STAT);\n'
    
    for p in param:
        text = text + ('        m_%s = %s;\n' % (p[1], p[1]))
 
    text = text + '    }\n\n'

    text = text + '''\

    protected final Object fillResult(final ResultSet rs)
                throws SQLException 
    {
        throw new RuntimeException("Should not be called on Update query");
    }

'''

    text = text + '    protected final void fillParam(final PreparedStatement ps)\n'
    text = text + '            throws SQLException\n'
    text = text + '    {\n'
    text = text + '        int i = 1;\n'
    for p in param:
	g = ''
	if p[0] == 'boolean': 
	    g = 'ps.setString(i++, m_%s ? "t" : "f")'
	else: 
	    g = 'ps.set' + string.capitalize(p[0]) + '(i++, m_%s)'

        text = text + '        ' + (g % p[1]) + ';\n'

    text = text + '    }\n\n'
    text = text + '}\n'
    
    return text




###############################################################
#  
if __name__ == '__main__':
    tuple = [];
    for idx in range(len(s_query)):
        tuple = tuple + [(idx, s_query[idx][0]) + parseQuery(s_query[idx][1])];

    # make update class
    for t in tuple:
        classText = makeUpdateClass(t[0], t[1], t[2], t[3], t[4])
        fname = t[1] + '.java';
        diff = writeIfDiff(fname, classText)
        if diff:
            print 'touch:', fname
        else:
            print 'leave:', fname

